<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelVendCupomPromoService {

	public function __construct(EntityManager $entityManager) {
      $this->entityManager = $entityManager;
  }
  
  public function find($conditions) {
    $params = array(
      ":CDFILIAL" => $conditions[':CDFILIAL'],
      ":DATAINI" => $conditions[':DATAINI'],
      ":DATAFIN" => $conditions[':DATAFIN'],
      ":CDLOJA" => $conditions['CDLOJA'],
      ":TCDLOJA" => $conditions['TCDLOJA'],
      ":CDCUPOMDESCFOS" => $conditions['CDCUPOMDESCFOS'],
      ":TCDCUPOMDESCFOS" => $conditions['TCDCUPOMDESCFOS'],
      ":CDPRODLIST" => $conditions['CDPRODLIST'],
      ":CDARVPRODI" => $conditions['CDARVPRODI'],
      ":CDARVPRODF" => $conditions['CDARVPRODF'],
      ":PRODNIV" => $conditions['PRODNIV'],
      ":TCDPRODUTO" => $conditions['TCDPRODUTO'],
      ":NRORG" => $conditions[':NRORG']
 	);
 	return $this->entityManager->getConnection()->fetchAll(self::GET_SALES_CUPOM_DESCONTO, $params);
  }
  
  const GET_SALES_CUPOM_DESCONTO = "
      SELECT SUM(I.QTPRODVEND) AS QTPRODVEN, FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS LABELFILIAL, 
           FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.NRORG, FILOCAVE.DTENTRVENDA,
           P.CDARVPROD, P.NMPRODUTO, U.CDCUPOMDESCFOS, CPF.DSCUPOMDESCFOS,
           U.CDCUPOMDESCFOS||' - '||CPF.DSCUPOMDESCFOS AS LABELCUPOMDESCFOS
            FROM ITEMVENDA I
            JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, V.DTVENDA,
                        FILOCA.NRORG, V.DTENTRVENDA, NVL(V.NRCUPOMFIS, V.NRNOTAFISCALCE) AS CUPOM, V.CDCONSUMIDOR
                   FROM VENDA V
                   JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                           FROM CAIXA C
                           JOIN (SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                   FROM LOJA L
                                   JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                           FROM FILIAL F
                                          WHERE (INSTR(:CDFILIAL, F.CDFILIAL) > 0)
                                            AND F.NRORG =:NRORG ) FI 
                                     ON L.CDFILIAL = FI.CDFILIAL
                                    AND L.NRORG = FI.NRORG 
                                  WHERE ((INSTR(:CDLOJA, L.CDLOJA||L.CDFILIAL) > 0) OR (:TCDLOJA = 'T'))) FILO 
                             ON C.CDFILIAL = FILO.CDFILIAL 
                            AND C.CDLOJA = FILO.CDLOJA
                            AND C.NRORG = FILO.NRORG
                        ) FILOCA 
                     ON V.CDCAIXA = FILOCA.CDCAIXA
                    AND V.CDLOJA = FILOCA.CDLOJA
                    AND V.CDFILIAL = FILOCA.CDFILIAL
                    AND V.NRORG = FILOCA.NRORG
                  WHERE V.IDSITUVENDA = 'O'
                    AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN) FILOCAVE
              ON I.CDFILIAL = FILOCAVE.CDFILIAL
             AND I.CDCAIXA = FILOCAVE.CDCAIXA
             AND I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
             AND I.NRORG = FILOCAVE.NRORG
            JOIN PRODUTO P
              ON I.CDPRODUTO = P.CDPRODUTO
             AND I.NRORG = P.NRORG
            JOIN USOCUPOMDESCFOS U
              ON I.CDFILIAL = U.CDFILIAL
             AND I.CDCAIXA = U.CDCAIXA
             AND I.NRSEQVENDA = U.NRSEQVENDA
             AND I.NRSEQUITVEND = U.NRSEQUITVEND
            JOIN CUPOMDESCFOS CPF
              ON U.CDCUPOMDESCFOS = CPF.CDCUPOMDESCFOS
           WHERE ((INSTR(:CDCUPOMDESCFOS, U.CDCUPOMDESCFOS) > 0) OR (:TCDCUPOMDESCFOS = 'T'))
             AND (((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0 ) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF ))) OR (P.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
           GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.NRORG, FILOCAVE.DTENTRVENDA, 
                   P.CDARVPROD, P.NMPRODUTO, U.CDCUPOMDESCFOS, CPF.CDCUPOMDESCFOS, CPF.DSCUPOMDESCFOS
  ";
  
  //
  
  const QUERY_COM_TIPO_CONS = "
      SELECT SUM((I.QTPRODVEND *(I.VRUNITVEND + I.VRUNITVENDCL) - (I.VRDESITVEND) + (I.VRACRITVEND))) AS VRTOTITEM, U.NRSEQVENDA, FILOCAVE.CDCAIXA||' -' ||FILOCAVE.NMCAIXA AS LABELCAIXA, 
           FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDLOJA||' - '||FILOCAVE.NMLOJA AS LABELLOJA, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS LABELFILIAL, 
           FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.DTVENDA, FILOCAVE.NRORG, FILOCAVE.DTENTRVENDA, FILOCAVE.CUPOM, FILOCAVE.CDCONSUMIDOR,
           FILOCAVE.NMCONSUMIDOR, FILOCAVE.CDCONSUMIDOR||' - '||FILOCAVE.NMCONSUMIDOR AS LABELCONSUMIDOR, FILOCAVE.CDTIPOCONS, FILOCAVE.NMTIPOCONS, FILOCAVE.CDTIPOCONS||' - '||FILOCAVE.NMTIPOCONS AS LABELTIPOCONS,
           P.CDARVPROD, P.NMPRODUTO, U.CDCUPOMDESCFOS,  U.NRSEQUITVEND, CPF.CDCUPOMDESCFOS, CPF.DSCUPOMDESCFOS, U.CDCUPOMDESCFOS||' - '||CPF.DSCUPOMDESCFOS AS LABELCUPOMDESCFOS
            FROM ITEMVENDA I
            JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, V.DTVENDA,
                        FILOCA.NRORG, V.DTENTRVENDA, NVL(V.NRCUPOMFIS, V.NRNOTAFISCALCE) AS CUPOM, V.CDCONSUMIDOR, C.NMCONSUMIDOR, C.CDTIPOCONS, TC.NMTIPOCONS
                   FROM VENDA V
                   JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                           FROM CAIXA C
                           JOIN (SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                   FROM LOJA L
                                   JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                           FROM FILIAL F
                                          WHERE (INSTR(:CDFILIAL, F.CDFILIAL) > 0)
                                            AND F.NRORG =:NRORG ) FI 
                                     ON L.CDFILIAL = FI.CDFILIAL
                                    AND L.NRORG = FI.NRORG ) FILO 
                             ON C.CDFILIAL = FILO.CDFILIAL 
                            AND C.CDLOJA = FILO.CDLOJA
                            AND C.NRORG = FILO.NRORG
                          WHERE ((INSTR(:CDCAIXA, FILO.CDFILIAL ||C.CDCAIXA) > 0) OR (:TCDCAIXA = 'T'))) FILOCA 
                     ON V.CDCAIXA = FILOCA.CDCAIXA
                    AND V.CDLOJA = FILOCA.CDLOJA
                    AND V.CDFILIAL = FILOCA.CDFILIAL
                    AND V.NRORG = FILOCA.NRORG
                   JOIN CONSUMIDOR C
                     ON V.CDCONSUMIDOR = C.CDCONSUMIDOR
                    AND V.NRORG = C.NRORG
                   JOIN TIPOCONS TC
                     ON C.CDTIPOCONS = TC.CDTIPOCONS
                    AND C.NRORG = TC.NRORG
                  WHERE V.IDSITUVENDA = 'O'
                    AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                    AND ((INSTR(:CDCONSUMIDOR, V.CDCONSUMIDOR) > 0) OR (:TCDCONSUMIDOR = 'T'))
                    AND ((INSTR(:CDTIPOCONS, C.CDTIPOCONS) > 0) OR (:TCDCONSUMIDOR = 'T'))) FILOCAVE
              ON I.CDFILIAL = FILOCAVE.CDFILIAL
             AND I.CDCAIXA = FILOCAVE.CDCAIXA
             AND I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
             AND I.NRORG = FILOCAVE.NRORG
            JOIN PRODUTO P
              ON I.CDPRODUTO = P.CDPRODUTO
             AND I.NRORG = P.NRORG
            JOIN USOCUPOMDESCFOS U
              ON I.CDFILIAL = U.CDFILIAL
             AND I.CDCAIXA = U.CDCAIXA
             AND I.NRSEQVENDA = U.NRSEQVENDA
             AND I.NRSEQUITVEND = U.NRSEQUITVEND
            JOIN CUPOMDESCFOS CPF
              ON U.CDCUPOMDESCFOS = CPF.CDCUPOMDESCFOS
           GROUP BY FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
                   FILOCAVE.DTVENDA, FILOCAVE.NRORG, FILOCAVE.DTENTRVENDA, FILOCAVE.CUPOM, FILOCAVE.CDCONSUMIDOR,
                   FILOCAVE.NMCONSUMIDOR, FILOCAVE.CDTIPOCONS, FILOCAVE.NMTIPOCONS, U.NRSEQVENDA, 
                   P.CDARVPROD, P.NMPRODUTO, U.CDCUPOMDESCFOS, U.NRSEQUITVEND, CPF.CDCUPOMDESCFOS, CPF.DSCUPOMDESCFOS
  ";
  
  
}